/**
 * TestCommand1 requires the following properties to be configured:<br>
 * Please note that <strong>ALL PROPERTIES REQUIRE AN INPUT VALUE!</strong>
 * @typedef {CommandContext} TestCommand1.cmdConfiguration
 * @property {}
 * @example <caption>Sample configuration</caption>
 */

/**
 * To configure the TestCommand1 result data
 * @typedef {CommandResult} TestCommand1.commandResult
 * @property {string} cmd - this.constructor.name ( The current command name )
 * @property {Object} data - an array with values 1,2,3
 * @property {string} msg - A description of the result object.
 * @example <caption>Sample output</caption>
 */

Command = require('../../../../../bin/commands/command');

/**
 * @class
 * @augments Command
 * @description This is a test class that does nothing except returning an array.
 */
class TestCommand1 extends Command {

/**
 * @override
 * @param {TestCommand1.cmdConfiguration} context.parameters.cmdConfiguration - Holds all the required configurations for this command to run.
 * @return {Promise.<TestCommand1.commandResult>} A promise to the client.
 * @return TestCommand1.commandResult
 */
execute(context) {

        var key = this.constructor.name;
        this.context = context;
        var self = this;
        var cmdConf = context.parameters.cmdConfiguration;

        return new Promise(function (resolve, reject) {

            //CHECK REQUIRED INPUT PARAMETERS ...

            //DO SOMETHING HERE ...

            self.result.cmd = key;
            self.result.data.push({ anArray: [1,2,3] });
            self.result.msg = 'The result from ' + key;
            resolve(self.result);

        });
    }
}

module.exports = TestCommand1;